#!/usr/bin/env python3
import pymysql
import webiopi
import serial
import minimalmodbus
import json
import sys
import time
import datetime
import os
import subprocess
from time import strftime
from subprocess import call


from webiopi.devices.sensor.bmp085 import BMP085
from webiopi import deviceInstance
pressure, celsius, celsius_0, celsius_1 = 0, 0, 0, 0


#=========================================================================
#====================================     SCRIPT     =====================
#=========================================================================


#=========================== SLAVE == ИНИЦИАЛИЗАЦИЯ С АДРЕСОМ 1========

instrumentA = minimalmodbus.Instrument(
    '/dev/ttyUSB0', 1) 	# slave address (in decimal)
instrumentA.mode = minimalmodbus.MODE_RTU   				# rtu or ascii mode
instrumentA.serial.baudrate = 9600  						# baud
instrumentA.serial.bytesize = 8
instrumentA.serial.parity = serial.PARITY_NONE
instrumentA.serial.stopbits = 2
instrumentA.serial.timeout = 1   							# seconds

a0 = 0
a1 = 0
a2 = 0
a3 = 0
a4 = 0
a5 = 0
a6 = 0
a7 = 0
a8 = 0
a9 = 0

b0 = 0
b1 = 0
b2 = 0
b3 = 0
b4 = 0
b5 = 0
b6 = 0
b7 = 0
b8 = 0
b9 = 0
b10 = 0

i0 = 0
i1 = 0
i2 = 0
i3 = 0
i4 = 0
i5 = 0
i6 = 0
i7 = 0
i8 = 0
i9 = 0
i10 = 0
i11 = 0
i12 = 0


#=========================================================================
#==================================== МАКРОСЫ ВЫЗЫВАЕМЫЕ ИЗ HTML страницы
#=========================================================================
@webiopi.macro
def getEnergy():
    conn = pymysql.connect(host='127.0.0.1', user='counters',
                           passwd='32157895', db='counters', charset='utf8')
    cur = conn.cursor()
    cur.execute('SELECT SUM(count) FROM energy')
    # print cur.description
    # r = cur.fetchall()
    # print r
    # ...or...
    for energy in cur:
        print (energy)
    return energy
    cur.close()
    conn.close()

@webiopi.macro
def getAlert():
    conn = pymysql.connect(host='127.0.0.1', user='smsd',
                           passwd='32157895', db='smsd', charset='utf8')
    cur = conn.cursor()
    cur.execute("INSERT INTO outbox (DestinationNumber,	TextDecoded, CreatorID,	Coding) VALUES ('+79226396761','Тревога! Что-то случилось!!','WebIOPi','Unicode_No_Compression')")
    cur.close()
    conn.close()

@webiopi.macro
def getBalance():
    conn = pymysql.connect(host='127.0.0.1', user='smsd',
                           passwd='32157895', db='smsd', charset='utf8')
    cur = conn.cursor()
    cur.execute('SELECT SUBSTRING(TextDecoded, 13, 5) FROM inbox WHERE SenderNumber=111 AND ReceivingDateTime=(SELECT MAX(ReceivingDateTime) FROM inbox) GROUP BY SenderNumber')
    for balance in cur:
        print (balance)
    return balance
    cur.close()
    conn.close()

@webiopi.macro
def getSMSBalance():
    conn = pymysql.connect(host='127.0.0.1', user='smsd',
                           passwd='32157895', db='smsd', charset='utf8')
    cur = conn.cursor()
    cur.execute("INSERT INTO outbox (DestinationNumber,	TextDecoded, CreatorID,	Coding) VALUES ('111','11','WebIOPi','Unicode_No_Compression')")
    cur.close()
    conn.close()	
	
# ################## ПОЛУЧЕНИЕ СОСТОЯНИЯ МЕТЕОСТАНЦИИ ##################

# @webiopi.macro
# def getData():
# instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 1)
# global i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12
# try:
    # i0 = instrumentA.read_register(0, 0) # Чтение регистров данных
    # i1 = instrumentA.read_register(1, 0)
    # i2 = instrumentA.read_register(2, 0)
    # i3 = instrumentA.read_register(3, 0)
    # i4 = instrumentA.read_register(4, 0)
    # i5 = instrumentA.read_register(5, 0)
    # i6 = instrumentA.read_register(6, 0)
    # i7 = instrumentA.read_register(7, 0)
    # i8 = instrumentA.read_register(8, 0)
    # i9 = instrumentA.read_register(9, 0)
    # i10 = instrumentA.read_register(10, 0)
    # i11 = instrumentA.read_register(11, 0)
    # i12 = instrumentA.read_register(12, 0)

    # #i4 = instrument.read_bit(0) 		# Чтение бит (входы)
    # #i5 = instrument.read_bit(1)
    # #i6 = instrument.read_bit(2)
    # #i7 = instrument.read_bit(3)

    # #out_0 = instrument.write_bit(0,1)	# Запись бит (выходы)
    # #out_1 = instrument.write_bit(1,1)

    # lista = i0,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12
    # print("lista",lista)
    # return json.dumps(lista)


# except IOError:
# #		print "Connection problem, gonna try again"
    # pass
    # #os._exit()
# #webiopi.sleep(1)


@webiopi.macro
def getBMP085():							# макрос измерения давления
    global pressure
    bmp = BMP085()
    pressure = bmp.getHectoPascal()		# получение давления в гектопаскалях
    pressure = pressure * 0.75			# перевод гектопаскалей в мм.рт.ст
    print (pressure)
    # возврат данных давления в HTML с округлением до десятых / "%d" % - до целых
    return '%.1f' % pressure


@webiopi.macro							# макрос измерения давления
def getBMP085tmp():
    global celsius
    bmp = BMP085()
    celsius = bmp.getCelsius()			# получение температуры
    print (celsius)
    return '%.1f' % celsius				# возврат данных температуры в HTML с округлением до десятых


@webiopi.macro
def getCelsius_0():
    global celsius_0
    tmp0 = webiopi.deviceInstance('tmp0')
    celsius_0 = tmp0.getCelsius() 		# получение температуры
    print (celsius_0)
    # возврат данных температуры в HTML с округлением до десятых
    return '%.1f' % celsius_0


@webiopi.macro
def getCelsius_1():
    global celsius_1
    tmp1 = webiopi.deviceInstance('tmp1')
    celsius_1 = tmp1.getCelsius() 		# получение температуры
    print (celsius_1)
    # возврат данных температуры в HTML с округлением до десятых
    return '%.1f' % celsius_1


################## ПОЛУЧЕНИЕ СОСТОЯНИЯ РАДИОКОНТРОЛЛЕРА ##################

@webiopi.macro
def getRadio():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 2)
    global a0, a1, a2, a3, a4, a5, a6, a7, a8, a9
    a0 = instrumentA.read_register(1, 0)
    a1 = instrumentA.read_register(2, 0)
    a2 = instrumentA.read_register(3, 0)
    a3 = instrumentA.read_register(4, 0)
    a4 = instrumentA.read_register(5, 0)
    a5 = instrumentA.read_register(6, 0)
    a6 = instrumentA.read_register(7, 0)
    a7 = instrumentA.read_register(8, 0)
    a8 = instrumentA.read_register(9, 0)
    a9 = instrumentA.read_register(10, 0)

    lista = a0, a1, a2, a3, a4, a5, a6, a7, a8, a9
    print('lista', lista)
    return json.dumps(lista)


################## УПРАВЛЕНИЕ РАДИОКОНТРОЛЛЕРОМ ##########################


@webiopi.macro
def getTX_1_1():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 2)
    global TX_1_1
    # Запись байта 1-й пульт, 1 = 00 01; 0 - знаков dex, 6 - функция
    light1_on = instrumentA.write_register(1, 1, 0, 6, False)


@webiopi.macro
def getTX_1_2():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 2)
    global TX_1_2
    light1_off = instrumentA.write_register(
        1, 2, 0, 6, False)		# Запись байта 1-й пульт, 2 = 00 02;


@webiopi.macro
def getTX_1_3():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 2)
    global TX_1_3
    # Запись байта 1-й пульт, 3 = 00 03;
    TX_1_4 = instrumentA.write_register(1, 3, 0, 6, False)


@webiopi.macro
def getTX_1_4():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 2)
    global TX_1_4
    # Запись байта 1-й пульт, 4 = 00 04;
    TX_1_4 = instrumentA.write_register(1, 4, 0, 6, False)


@webiopi.macro
def getTX_2_1():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 2)
    global TX_2_1
    # Запись байта 2-й пульт, 1 = 00 01;
    TX_2_1 = instrumentA.write_register(2, 1, 0, 6, False)


@webiopi.macro
def getTX_2_2():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 2)
    global TX_2_2
    # Запись байта 2-й пульт, 2 = 00 02;
    TX_2_2 = instrumentA.write_register(2, 2, 0, 6, False)


@webiopi.macro
def getTX_2_3():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 2)
    global TX_2_3
    # Запись байта 2-й пульт, 3 = 00 03;
    TX_2_3 = instrumentA.write_register(2, 3, 0, 6, False)


@webiopi.macro
def getTX_2_4():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 2)
    global TX_2_4
    # Запись байта 2-й пульт, 4 = 00 04;
    TX_2_4 = instrumentA.write_register(2, 4, 0, 6, False)


@webiopi.macro
def getTX_3_1():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 2)
    global TX_3_1
    # Запись байта 3-й пульт, 1 = 00 01;
    TX_3_1 = instrumentA.write_register(3, 1, 0, 6, False)


@webiopi.macro
def getTX_3_2():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 2)
    global TX_3_2
    # Запись байта 3-й пульт, 2 = 00 02;
    TX_3_2 = instrumentA.write_register(3, 2, 0, 6, False)


@webiopi.macro
def getTX_3_3():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 2)
    global TX_3_3
    # Запись байта 3-й пульт, 3 = 00 03;
    TX_3_3 = instrumentA.write_register(3, 3, 0, 6, False)


@webiopi.macro
def getTX_3_4():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 2)
    global TX_3_4
    # Запись байта 3-й пульт, 4 = 00 04;
    TX_3_4 = instrumentA.write_register(3, 4, 0, 6, False)


@webiopi.macro
def getTX_4_1():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 2)
    global TX_4_1
    # Запись байта 4-й пульт, 1 = 00 01;
    TX_4_1 = instrumentA.write_register(4, 1, 0, 6, False)


@webiopi.macro
def getTX_4_2():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 2)
    global TX_4_2
    # Запись байта 4-й пульт, 2 = 00 02;
    TX_4_2 = instrumentA.write_register(4, 2, 0, 6, False)


@webiopi.macro
def getTX_4_3():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 2)
    global TX_4_3
    # Запись байта 4-й пульт, 3 = 00 03;
    TX_4_3 = instrumentA.write_register(4, 3, 0, 6, False)


@webiopi.macro
def getTX_4_4():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 2)
    global TX_4_4
    # Запись байта 4-й пульт, 4 = 00 04;
    TX_4_4 = instrumentA.write_register(4, 4, 0, 6, False)


@webiopi.macro
def getTX_5_1():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 2)
    global TX_5_1
    # Запись байта 5-й пульт, 1 = 00 01;
    TX_5_1 = instrumentA.write_register(5, 1, 0, 6, False)


@webiopi.macro
def getTX_5_2():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 2)
    global TX_5_2
    # Запись байта 5-й пульт, 2 = 00 02;
    TX_5_2 = instrumentA.write_register(5, 2, 0, 6, False)


@webiopi.macro
def getTX_5_3():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 2)
    global TX_5_3
    # Запись байта 5-й пульт, 3 = 00 03;
    TX_5_3 = instrumentA.write_register(5, 3, 0, 6, False)


@webiopi.macro
def getTX_5_4():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 2)
    global TX_5_4
    # Запись байта 5-й пульт, 4 = 00 04;
    TX_5_4 = instrumentA.write_register(5, 4, 0, 6, False)


################## СБРОС СИГНАЛА ТРЕВОГИ С ДАТЧИКОВ ######################


# Сбросить сигнал тревоги (обнулить входы)
@webiopi.macro
def getReset():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 2)
    global reset
    # Запись байта 6-й пульт (условно), 0 = 00 00;
    reset = instrumentA.write_register(6, 0, 0, 6, False)

################## ПОЛУЧЕНИЕ СОСТОЯНИЯ 4-Х КАНАЛЬНОГО КОНТРОЛЛЕРА ########


@webiopi.macro
def getControl1():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 4)
    global b0, b1, b2, b3, b4, b5, b6, b7, b8, b9, b10

    b0 = instrumentA.read_register(1, 0)
    b1 = instrumentA.read_register(2, 0)
    b2 = instrumentA.read_register(3, 0)
    b3 = instrumentA.read_register(4, 0)
    b4 = instrumentA.read_register(5, 0)
    b5 = instrumentA.read_register(6, 0)
    b6 = instrumentA.read_register(7, 0)
    b7 = instrumentA.read_register(8, 0)
    b8 = instrumentA.read_register(9, 0)
    b9 = instrumentA.read_register(10, 0)
    b10 = instrumentA.read_register(11, 0)		# регистр знака температуры

    if b10 == 1:								# Проверка отрицательной температуры
        b8 = -b8
        print(b8)
    else:
        print(b8)

    lista = b0, b1, b2, b3, b4, b5, b6, b7, b8, b9, b10
    print('lista', lista)

    return json.dumps(lista)


################## УПРАВЛЕНИЕ 4-Х КАНАЛЬНЫМ КОНТРОЛЛЕРОМ #################


# Управление каналом №1

# Включить
@webiopi.macro
def getContr1_ch1_on():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 4)
    global out1
    # Запись байта 1-канал, 1 = 00 01; 0 - знаков dex, 6 - функция
    out1 = instrumentA.write_register(1, 1, 0, 6, False)

# Отключить


@webiopi.macro
def getContr1_ch1_off():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 4)
    global out1
    # Запись байта 1-канал, 0 = 00 00;
    out1 = instrumentA.write_register(1, 0, 0, 6, False)

#=============================

# Управление каналом №2

# Включить


@webiopi.macro
def getContr1_ch2_on():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 4)
    global out2
    # Запись байта 2-канал, 1 = 00 01;
    out2 = instrumentA.write_register(2, 1, 0, 6, False)

# Отключить


@webiopi.macro
def getContr1_ch2_off():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 4)
    global out2
    # Запись байта 2-канал, 0 = 00 00;
    out2 = instrumentA.write_register(2, 0, 0, 6, False)

#=============================

# Управление каналом №3

# Включить


@webiopi.macro
def getContr1_ch3_on():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 4)
    global out3
    # Запись байта 3-канал, 1 = 00 01;
    out3 = instrumentA.write_register(3, 1, 0, 6, False)

# Отключить


@webiopi.macro
def getContr1_ch3_off():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 4)
    global out3
    # Запись байта 3-канал, 0 = 00 00;
    out3 = instrumentA.write_register(3, 0, 0, 6, False)

#=============================

# Управление каналом №4

# Включить


@webiopi.macro
def getContr1_ch4_on():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 4)
    global out4
    # Запись байта 4-канал, 1 = 00 01;
    out4 = instrumentA.write_register(4, 1, 0, 6, False)

# Отключить


@webiopi.macro
def getContr1_ch4_off():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 4)
    global out4
    # Запись байта 4-канал, 0 = 00 00;
    out4 = instrumentA.write_register(4, 0, 0, 6, False)

################## ЦИКЛ ОПРОСА РАДИОМОДУЛЯ ######################
	
def loop():
    instrumentA = minimalmodbus.Instrument('/dev/ttyUSB0', 2)
    a0 = instrumentA.read_register(1, 0)
    a1 = instrumentA.read_register(2, 0)
    a2 = instrumentA.read_register(3, 0)
    a4 = instrumentA.read_register(5, 0)
    a5 = instrumentA.read_register(6, 0)
    a6 = instrumentA.read_register(7, 0)
    a7 = instrumentA.read_register(8, 0)
    a8 = instrumentA.read_register(9, 0)
    a9 = instrumentA.read_register(10, 0)

    print(a0, a1, a2, a3, a4, a5, a6, a7, a8, a9)
    if a0 > 0:
        conn = pymysql.connect(host='127.0.0.1', user='smsd',
                               passwd='32157895', db='smsd', charset='utf8')
        cur = conn.cursor()
        cur.execute("INSERT INTO outbox (DestinationNumber,   TextDecoded, CreatorID,   Coding) VALUES ('+79226396761','Тревога! Вода в ванной!','WebIOPi','Unicode_No_Compression')")
        cur.close()
        conn.close()
    if a1 > 0:
        conn = pymysql.connect(host='127.0.0.1', user='smsd',
                               passwd='32157895', db='smsd', charset='utf8')
        cur = conn.cursor()
        cur.execute("INSERT INTO outbox (DestinationNumber,   TextDecoded, CreatorID,   Coding) VALUES ('+79226396761','Тревога! Вода на кухне!','WebIOPi','Unicode_No_Compression')")
        cur.close()
        conn.close()
    if a2 > 0:
        conn = pymysql.connect(host='127.0.0.1', user='smsd',
                               passwd='32157895', db='smsd', charset='utf8')
        cur = conn.cursor()
        cur.execute("INSERT INTO outbox (DestinationNumber,   TextDecoded, CreatorID,   Coding) VALUES ('+79226396761','Тревога! Вода в туалете!','WebIOPi','Unicode_No_Compression')")
        cur.close()
        conn.close()

    time.sleep(3600)
    webiopi.sleep(1)	